import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"vscode-django","displayName":"Django","description":"Beautiful syntax and scoped snippets for perfectionists with deadlines","version":"1.15.0","publisher":"batisteo","license":"MIT","icon":"images/vscode-django-icon.png","galleryBanner":{"color":"#0c4b33","theme":"dark"},"engines":{"vscode":"^1.49.0"},"recommendations":["ms-python.python"],"keywords":["python","django","web"],"categories":["Programming Languages","Snippets"],"homepage":"https://github.com/vscode-django/vscode-django","repository":{"type":"git","url":"https://github.com/vscode-django/vscode-django"},"bugs":{"url":"https://github.com/vscode-django/vscode-django/issues"},"contributes":{"languages":[{"id":"django-html","aliases":["Django HTML","django"],"filenamePatterns":["**/templates/**/*.html"],"firstLine":"{%","configuration":"./language-configuration.json"},{"id":"django-txt","aliases":["Django txt","django"],"filenamePatterns":["**/templates/**/*"],"firstLine":"{%","configuration":"./language-configuration.json"}],"grammars":[{"language":"django-html","scopeName":"text.html.django","path":"./syntaxes/django-html.tmLanguage.json"},{"language":"django-txt","scopeName":"text.django","path":"./syntaxes/django-txt.tmLanguage.json"}],"snippets":[{"language":"django-html","path":"./snippets/templates/tags.json"},{"language":"django-html","path":"./snippets/templates/filters.json"},{"language":"django-txt","path":"./snippets/templates/tags.json"},{"language":"django-txt","path":"./snippets/templates/filters.json"}],"configurationDefaults":{"[django-html]":{"editor.quickSuggestions":{"other":true,"comments":true,"strings":true}}},"configuration":{"type":"object","title":"Django configuration","properties":{"django.snippets.use":{"type":"boolean","default":true,"description":"Activates the Python snippets"},"django.snippets.exclude":{"type":"array","default":["cms","wagtail"],"description":"Exclude Python snippets by their file name. Can be 'import', 'postgres'..."},"django.i18n":{"type":"boolean","default":true,"description":"Activates the i18n features for snippets (eg.: _(\"\"))"},"django.showContributeNotification":{"type":"boolean","default":true,"description":"Seldom show notifications about this extension"}}}}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/README.md', import.meta.url).href, {"mimeType":"text/markdown","size":2879});

registerFileUrl('CHANGELOG.md', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/CHANGELOG.md', import.meta.url).href, {"mimeType":"text/markdown","size":231});

registerFileUrl('syntaxes/django-html.tmLanguage.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/django-html.tmLanguage.json', import.meta.url).href, {"mimeType":"application/json","size":18495});

registerFileUrl('syntaxes/django-txt.tmLanguage.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/django-txt.tmLanguage.json', import.meta.url).href, {"mimeType":"application/json","size":7276});

registerFileUrl('language-configuration.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":2687});

registerFileUrl('snippets/templates/tags.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/tags.json', import.meta.url).href, {"mimeType":"application/json","size":14265});

registerFileUrl('snippets/templates/filters.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/filters.json', import.meta.url).href, {"mimeType":"application/json","size":7363});

registerFileUrl('package.json', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/package.json', import.meta.url).href, {"mimeType":"application/json","size":4416});

registerFileUrl('images/vscode-django-icon.png', new URL('../assets/batisteo.vscode-django-1.15.0.vsix/vscode-django-icon.png', import.meta.url).href, {"mimeType":"image/png","size":8502});

export { whenReady };
