import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"csharp","publisher":"ms-dotnettools","version":"2.24.17","description":"Base language support for C#","displayName":"C#","author":"Microsoft Corporation","license":"SEE LICENSE IN RuntimeLicenses/license.txt","qna":"https://github.com/dotnet/vscode-csharp/issues","icon":"images/csharpIcon.png","preview":false,"bugs":{"url":"https://github.com/dotnet/vscode-csharp"},"repository":{"type":"git","url":"https://github.com/dotnet/vscode-csharp"},"categories":["Debuggers","Programming Languages","Linters","Snippets"],"keywords":["multi-root ready",".NET","ASP.NET",".NET Core","dotnet","coreclr"],"capabilities":{"virtualWorkspaces":false,"untrustedWorkspaces":{"supported":false}},"defaults":{"roslyn":"4.11.0-1.24179.11","omniSharp":"1.39.11","razor":"7.0.0-preview.24175.3","razorOmnisharp":"7.0.0-preview.23363.1","razorTelemetry":"7.0.0-preview.24175.3"},"brokeredServices":[{"moniker":{"name":"Microsoft.CodeAnalysis.LanguageClient.SolutionSnapshotProvider","version":"0.1"}},{"moniker":{"name":"Microsoft.VisualStudio.CSharpExtension.BuildResultService","version":"0.1"}}],"runtimeDependencies":[{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 4.7.2 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-win-x64-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["win32"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.11/OmniSharp.exe","platformId":"win-x64","isFramework":true,"integrity":"E1AD559974430C9AA81819F1433583B0EE9A977D2DAAE1DE32D4D408503B2867"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-win-x64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["win32"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"win-x64","isFramework":false,"integrity":"A71FD29E6CACDF41FD44ACB9F8532BE33DBD4CB313513E47A031443F648BDBAB"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 4.7.2 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-win-arm64-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.11/OmniSharp.exe","platformId":"win-arm64","isFramework":true,"integrity":"D42BB3A146B9DED5C59630708A6FFB0F76B2067B31AE3A6596596AFFCE7D79C9"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-win-arm64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"win-arm64","isFramework":false,"integrity":"FFC67D2A97F8E04161BE2DCA5CE48ECEB1B09A3DD0FCE697122D5B77302FC152"},{"id":"OmniSharp","description":"OmniSharp for OSX (Mono / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-osx-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["darwin"],"architectures":["x86_64","arm64"],"binaries":["./mono.osx","./run"],"installTestPath":"./.omnisharp/1.39.11/run","platformId":"osx","isFramework":true,"integrity":"1E339604AE52F531655B57A1058EB56E5CE0E1311C62B4CE16BE7CD0D265AA50"},{"id":"OmniSharp","description":"OmniSharp for OSX (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-osx-x64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["darwin"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"osx-x64","isFramework":false,"integrity":"01571AE3B5DF4345E42B1EBD85601A654985590D403F40D2F802ED3204516350"},{"id":"OmniSharp","description":"OmniSharp for OSX (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-osx-arm64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["darwin"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"osx-arm64","isFramework":false,"integrity":"9318997071878AB2DD7ECA29F1C797449B6C5454A0CB78BED0D17121BEC37B10"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / x86)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-x86-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["linux"],"architectures":["x86","i686"],"binaries":["./mono.linux-x86","./run"],"installTestPath":"./.omnisharp/1.39.11/run","platformId":"linux-x86","isFramework":true,"integrity":"9568941017C31318D893669647042065985A0BA871708DA3688208D50CA7F452"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-x64-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["linux"],"architectures":["x86_64"],"binaries":["./mono.linux-x86_64","./run"],"installTestPath":"./.omnisharp/1.39.11/run","platformId":"linux-x64","isFramework":true,"integrity":"88B70F9D4D7587562C3F25EC1062E8A8120EBCE7083D56E91D9AE4A6C72E4340"},{"id":"OmniSharp","description":"OmniSharp for Linux (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-x64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["linux"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"linux-x64","isFramework":false,"integrity":"E58BE0F23DD84F2ACCEA245D7DBB8F9DE6ADEA354D44CB2A3F10D7F1326571D9"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-arm64-1.39.11.zip","installPath":".omnisharp/1.39.11","platforms":["linux"],"architectures":["arm64"],"binaries":["./mono.linux-arm64","./run"],"installTestPath":"./.omnisharp/1.39.11/run","platformId":"linux-arm64","isFramework":true,"integrity":"A10A5595AB0B13BD22495A7278995D9711B12F9EDE04AA3BB29CBE8F175EFABA"},{"id":"OmniSharp","description":"OmniSharp for Linux (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-arm64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["linux"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"linux-arm64","isFramework":false,"integrity":"D4794CBA966B9B5D0F731E1606E732D5C231D4B1D345788B837565914D880A0E"},{"id":"OmniSharp","description":"OmniSharp for Linux musl (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-musl-x64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["linux-musl"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"linux-musl-x64","isFramework":false,"integrity":"E8F924BB793C60B032FADE805030DF8F8F9B62F7FC32BF3B688EEA1B7E94B5DA"},{"id":"OmniSharp","description":"OmniSharp for Linux musl (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.11/omnisharp-linux-musl-arm64-net6.0-1.39.11.zip","installPath":".omnisharp/1.39.11-net6.0","platforms":["linux-musl"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.11-net6.0/OmniSharp.dll","platformId":"linux-musl-arm64","isFramework":false,"integrity":"223B58388C0F7226874DCA9053FE10B10739F2E43663DEED3F2F48C892E0D8E6"},{"id":"Debugger","description":".NET Core Debugger (Windows / x64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-win7-x64.zip","installPath":".debugger/x86_64","platforms":["win32"],"architectures":["x86_64","arm64"],"installTestPath":"./.debugger/x86_64/vsdbg-ui.exe","integrity":"A4C3C3856B1ABC6461C311AFCDC2373A604F9A5410BDBC279ECADACCE65D25A2"},{"id":"Debugger","description":".NET Core Debugger (Windows / ARM64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-win10-arm64.zip","installPath":".debugger/arm64","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.debugger/arm64/vsdbg-ui.exe","integrity":"470D1815E79706E4FD92EE1A559E052830822AD7DAF9B53907BAF0067AB261DC"},{"id":"Debugger","description":".NET Core Debugger (macOS / x64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-osx-x64.zip","installPath":".debugger/x86_64","platforms":["darwin"],"architectures":["x86_64","arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/x86_64/vsdbg-ui","integrity":"0912770DE5269B7FDF2DA7255D98B88A7FE5E109985E3131858571BD9DCFEC5E"},{"id":"Debugger","description":".NET Core Debugger (macOS / arm64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-osx-arm64.zip","installPath":".debugger/arm64","platforms":["darwin"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/arm64/vsdbg-ui","integrity":"F0DA97D676D2335A9F4C4526BC0BF5C6D49F0EB4F905705FBC4D3D675493E036"},{"id":"Debugger","description":".NET Core Debugger (linux / ARM)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-linux-arm.zip","installPath":".debugger","platforms":["linux"],"architectures":["arm"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"1502C8D4CB3F880476CFFE05B1B3E5552342F213E1A7795D44DDB4679041E2FF"},{"id":"Debugger","description":".NET Core Debugger (linux / ARM64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-linux-arm64.zip","installPath":".debugger","platforms":["linux"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"0A8E12B7A50BA28767BF0A036AEB893C9F12B89DB1AD87D0DC08410031C15447"},{"id":"Debugger","description":".NET Core Debugger (linux musl / x64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-linux-musl-x64.zip","installPath":".debugger","platforms":["linux-musl"],"architectures":["x86_64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"378D9ED5D02BC453405CEE9B730F38B161A1AA9066566825DE1E7469A084AFB9"},{"id":"Debugger","description":".NET Core Debugger (linux musl / ARM64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-linux-musl-arm64.zip","installPath":".debugger","platforms":["linux-musl"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"7BAABE9EEFD6FFC7DAE067AACA534EAFA26B43DCE64C8481A71833360E74308F"},{"id":"Debugger","description":".NET Core Debugger (linux / x64)","url":"https://vsdebugger.azureedge.net/coreclr-debug-2-19-17/coreclr-debug-linux-x64.zip","installPath":".debugger","platforms":["linux"],"architectures":["x86_64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"A8A3D0728BBB35352A0D8AF15E986ADF3C104F24FFAD4A5D38A03B91EC0177C0"},{"id":"Razor","description":"Razor Language Server (Windows / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/6e2578460774f15bced049d9d72020e1/razorlanguageserver-win-x64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["win32"],"architectures":["x86_64"],"integrity":"3B55C4269F5A02C3A5380066E2FCE2110810BA9032D92B585D3A78F0FEBA5753"},{"id":"Razor","description":"Razor Language Server (Windows / ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/8a25847c282c29e808ffbef3e1420d00/razorlanguageserver-win-arm64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["win32"],"architectures":["arm64"],"integrity":"43C6294BD7C46F3B3990246893D0D8FED651585FDE46DBC80BCB234B8F1CB53B"},{"id":"Razor","description":"Razor Language Server (Linux / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/3228534d690bda2e0261790a0a7bf9a8/razorlanguageserver-linux-x64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["linux"],"architectures":["x86_64"],"binaries":["./rzls"],"integrity":"275E356136B6282AF03B49125075A2D26CA31E614516E6DE7D354DF6FB3BDAB1"},{"id":"Razor","description":"Razor Language Server (Linux ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/1860e8fe11872d9dfd7165d7eae3597d/razorlanguageserver-linux-arm64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["linux"],"architectures":["arm64"],"binaries":["./rzls"],"integrity":"0421F10614D33999CAC0FDC28C3B486BFC9A12A45BF5A3963782C6A431D0A58D"},{"id":"Razor","description":"Razor Language Server (Linux musl / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/d3c9613d66ad9beedc02e24e3f0ed302/razorlanguageserver-linux-musl-x64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["linux-musl"],"architectures":["x86_64"],"binaries":["./rzls"],"integrity":"AAA30D53F1A087CA7A292CFCBE794A59B862927A48945BCA74B5D11793208B29"},{"id":"Razor","description":"Razor Language Server (Linux musl ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/73b9c9c57d5518a05a89c754dfaae8d4/razorlanguageserver-linux-musl-arm64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["linux-musl"],"architectures":["arm64"],"binaries":["./rzls"],"integrity":"D19DD2511293170203A82D8A8B4CB455D28E99C6E565EC6E0966FE614AD218D2"},{"id":"Razor","description":"Razor Language Server (macOS / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/aa05d02de40e721a169c4c2622eda9ca/razorlanguageserver-osx-x64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["darwin"],"architectures":["x86_64"],"binaries":["./rzls"],"integrity":"42FCED44EBEE5C0942C3B6D278598F21E0254235298384FEFA3B963873A64D62"},{"id":"Razor","description":"Razor Language Server (macOS ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/be3e610daa38f1c4b0848256c6392f36/razorlanguageserver-osx-arm64-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["darwin"],"architectures":["arm64"],"binaries":["./rzls"],"integrity":"369E1A18A3E95C65B3682964D382727F5C84B06BA434C6519D861A96E5AF62E2"},{"id":"Razor","description":"Razor Language Server (Platform Agnostic)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/6d1ec2d06b58e70e164923c7afa81bc5/razorlanguageserver-platformagnostic-7.0.0-preview.24175.3.zip","installPath":".razor","platforms":["neutral"],"architectures":["neutral"],"binaries":["./rzls"],"integrity":"98F0D1A8844C363F2B44264187F111416EF21B985BD768BA0F0413CB7E0DABBA"},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Windows / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/8d42e62ea4051381c219b3e31bc4eced/razorlanguageserver-win-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["win32"],"architectures":["x86_64"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Windows / ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/4ef26e45cf32fe8d51c0e7dd21f1fef6/razorlanguageserver-win-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["win32"],"architectures":["arm64"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/6d4e23a3c7cf0465743950a39515a716/razorlanguageserver-linux-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/85deebd44647ebf65724cc291d722283/razorlanguageserver-linux-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux"],"architectures":["arm64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux musl / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/4f0caa94ae182785655efb15eafcef23/razorlanguageserver-linux-musl-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux-musl"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux musl ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/0a24828206a6f3b4bc743d058ef88ce7/razorlanguageserver-linux-musl-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux-musl"],"architectures":["arm64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (macOS / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/2afcafaf41082989efcc10405abb9314/razorlanguageserver-osx-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["darwin"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (macOS ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/8bf2ed2f00d481a5987e3eb5165afddd/razorlanguageserver-osx-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["darwin"],"architectures":["arm64"],"binaries":["./rzls"]},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Windows / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/9cb17a23cfa811a57ebef544f6aa53ac/devkittelemetry-win-x64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["win32"],"architectures":["x86_64"],"integrity":"D07443D16A8A8886ACFD8727D4492C1B035BD193D3BFD579030F4868AC4EF3CB"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Windows / ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/0053a029fe51abe51c2c10a50979a208/devkittelemetry-win-arm64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["win32"],"architectures":["arm64"],"integrity":"C10F40D726A4BB6BFE8C9D8918DEB8754236D2A761B0AD9B3D9742399C2B225E"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Linux / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/733da378a1332e8514981ba0045bea6b/devkittelemetry-linux-x64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["linux"],"architectures":["x86_64"],"integrity":"8E8E323E23C18ED50A4B71ECBC51951985DCAD695AEDEC5DC4A2F7184DDCD877"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Linux ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/6b41ddb024bfee47992a0b4d5f8ef0e1/devkittelemetry-linux-arm64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["linux"],"architectures":["arm64"],"integrity":"A0F338177EC180DD2AE61ED1B3436D3D2CD6C974F77CACF9C9F33185600E1AA3"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Linux musl / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/bd70cd20bb79387ea83a0b0548e67fd3/devkittelemetry-linux-musl-x64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["linux-musl"],"architectures":["x86_64"],"integrity":"C4CDD5D3CC477EDD5B7BE594AFABD08F6F2F0DBED9D43C6AABC8A09E16CC4C4B"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Linux musl ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/bc19e6cbb7d098824b80592e327a3d26/devkittelemetry-linux-musl-arm64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["linux-musl"],"architectures":["arm64"],"integrity":"716311757FC8DA3D256D391575C8FBF9D7942AD5F15EC37E09D028E968AD0B2A"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (macOS / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/65b32224373413c608a3627b8784a75c/devkittelemetry-osx-x64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["darwin"],"architectures":["x86_64"],"integrity":"B83FF829A25F6D8764E371AC80A2AC684873E39D005A64B518CA5536DC0626AF"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (macOS ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/72a931e50ae1f99a5dcb6aad9a79a2a8/devkittelemetry-osx-arm64-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["darwin"],"architectures":["arm64"],"integrity":"17F174510FFC46BF5849767E8A8592214638670738B2C9E5AE2097312B2F1CF3"},{"id":"RazorTelemetry","description":"Razor Language Server Telemetry (Platform Agnostic)","url":"https://download.visualstudio.microsoft.com/download/pr/d5be2742-99d9-442b-ba28-8c9c64de88e7/7ae52e3961b64bd158e7f0580b9f3f6a/devkittelemetry-platformagnostic-7.0.0-preview.24175.3.zip","installPath":".razortelemetry","platforms":["netural"],"architectures":["neutral"],"integrity":"BA761ED08BA8A48866D1EF337F6032E174868CA3F7DBAAEE1DEFA8AC85B32BB4"}],"engines":{"vscode":"^1.75.0"},"contributes":{"themes":[{"label":"Visual Studio 2019 Dark","uiTheme":"vs-dark","path":"./themes/vs2019_dark.json"},{"label":"Visual Studio 2019 Light","uiTheme":"vs","path":"./themes/vs2019_light.json"}],"configuration":[{"title":"Project","order":0,"properties":{"dotnet.defaultSolution":{"type":"string","description":"%configuration.dotnet.defaultSolution.description%","order":0}}},{"title":"Text Editor","order":1,"properties":{"dotnet.implementType.insertionBehavior":{"type":"string","enum":["withOtherMembersOfTheSameKind","atTheEnd"],"default":"withOtherMembersOfTheSameKind","enumDescriptions":["%configuration.dotnet.implementType.insertionBehavior.withOtherMembersOfTheSameKind%","%configuration.dotnet.implementType.insertionBehavior.atTheEnd%"],"description":"%configuration.dotnet.implementType.insertionBehavior%","order":10},"dotnet.implementType.propertyGenerationBehavior":{"type":"string","enum":["preferThrowingProperties","preferAutoProperties"],"default":"preferThrowingProperties","enumDescriptions":["%configuration.dotnet.implementType.propertyGenerationBehavior.preferThrowingProperties%","%configuration.dotnet.implementType.propertyGenerationBehavior.preferAutoProperties%"],"description":"%configuration.dotnet.implementType.propertyGenerationBehavior%","order":10},"dotnet.codeLens.enableReferencesCodeLens":{"type":"boolean","default":true,"description":"%configuration.dotnet.codeLens.enableReferencesCodeLens%"},"dotnet.codeLens.enableTestsCodeLens":{"type":"boolean","default":true,"description":"%configuration.dotnet.codeLens.enableTestsCodeLens%"},"dotnet.completion.showCompletionItemsFromUnimportedNamespaces":{"type":"boolean","default":true,"description":"%configuration.dotnet.completion.showCompletionItemsFromUnimportedNamespaces%","order":20},"dotnet.completion.showNameCompletionSuggestions":{"type":"boolean","default":"true","description":"%configuration.dotnet.completion.showNameCompletionSuggestions%","order":20},"dotnet.completion.provideRegexCompletions":{"type":"boolean","default":"true","description":"%configuration.dotnet.completion.provideRegexCompletions%","order":20},"dotnet.backgroundAnalysis.analyzerDiagnosticsScope":{"type":"string","enum":["openFiles","fullSolution","none"],"default":"openFiles","enumDescriptions":["%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.openFiles%","%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.fullSolution%","%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.none%"],"description":"%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope%","order":30},"dotnet.backgroundAnalysis.compilerDiagnosticsScope":{"type":"string","enum":["openFiles","fullSolution","none"],"default":"openFiles","enumDescriptions":["%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.openFiles%","%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.fullSolution%","%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.none%"],"description":"%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope%","order":30},"dotnet.highlighting.highlightRelatedRegexComponents":{"type":"boolean","default":"true","description":"%configuration.dotnet.highlighting.highlightRelatedRegexComponents%","order":40},"dotnet.highlighting.highlightRelatedJsonComponents":{"type":"boolean","default":"true","description":"%configuration.dotnet.highlighting.highlightRelatedJsonComponents%","order":40},"csharp.inlayHints.enableInlayHintsForImplicitObjectCreation":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForImplicitObjectCreation%","order":50},"csharp.inlayHints.enableInlayHintsForImplicitVariableTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForImplicitVariableTypes%","order":50},"csharp.inlayHints.enableInlayHintsForLambdaParameterTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForLambdaParameterTypes%","order":50},"csharp.inlayHints.enableInlayHintsForTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForTypes%","order":50},"dotnet.inlayHints.enableInlayHintsForIndexerParameters":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForIndexerParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForLiteralParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForLiteralParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForObjectCreationParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForObjectCreationParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForOtherParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForOtherParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForParameters%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatDifferOnlyBySuffix":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatDifferOnlyBySuffix%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatMatchArgumentName":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatMatchArgumentName%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatMatchMethodIntent":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatMatchMethodIntent%","order":50},"dotnet.navigation.navigateToDecompiledSources":{"type":"boolean","default":"true","description":"%configuration.dotnet.navigation.navigateToDecompiledSources%","order":60},"dotnet.quickInfo.showRemarksInQuickInfo":{"type":"boolean","default":"true","description":"%configuration.dotnet.quickInfo.showRemarksInQuickInfo%","order":70},"dotnet.symbolSearch.searchReferenceAssemblies":{"type":"boolean","default":true,"description":"%configuration.dotnet.symbolSearch.searchReferenceAssemblies%","order":80}}},{"title":"Debugger","order":8,"properties":{"csharp.debug.stopAtEntry":{"type":"boolean","markdownDescription":"%generateOptionsSchema.stopAtEntry.markdownDescription%","default":false},"csharp.debug.console":{"type":"string","enum":["internalConsole","integratedTerminal","externalTerminal"],"enumDescriptions":["%generateOptionsSchema.console.internalConsole.enumDescription%","%generateOptionsSchema.console.integratedTerminal.enumDescription%","%generateOptionsSchema.console.externalTerminal.enumDescription%"],"markdownDescription":"%generateOptionsSchema.console.settingsDescription%","default":"internalConsole"},"csharp.debug.sourceFileMap":{"type":"object","markdownDescription":"%generateOptionsSchema.sourceFileMap.markdownDescription%","additionalProperties":{"type":"string"},"default":{}},"csharp.debug.justMyCode":{"type":"boolean","markdownDescription":"%generateOptionsSchema.justMyCode.markdownDescription%","default":true},"csharp.debug.requireExactSource":{"type":"boolean","markdownDescription":"%generateOptionsSchema.requireExactSource.markdownDescription%","default":true},"csharp.debug.enableStepFiltering":{"type":"boolean","markdownDescription":"%generateOptionsSchema.enableStepFiltering.markdownDescription%","default":true},"csharp.debug.logging.exceptions":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.exceptions.markdownDescription%","default":true},"csharp.debug.logging.moduleLoad":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.moduleLoad.markdownDescription%","default":true},"csharp.debug.logging.programOutput":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.programOutput.markdownDescription%","default":true},"csharp.debug.logging.browserStdOut":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.browserStdOut.markdownDescription%","default":true},"csharp.debug.logging.elapsedTiming":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.elapsedTiming.markdownDescription%","default":false},"csharp.debug.logging.threadExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.threadExit.markdownDescription%","default":false},"csharp.debug.logging.processExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.processExit.markdownDescription%","default":true},"csharp.debug.logging.engineLogging":{"type":"boolean","deprecationMessage":"%generateOptionsSchema.logging.engineLogging.deprecationMessage%","default":false},"csharp.debug.logging.diagnosticsLog.protocolMessages":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.protocolMessages.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.dispatcherMessages":{"type":"string","enum":["none","error","important","normal"],"enumDescriptions":["%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.none.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.error.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.important.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.normal.enumDescription%"],"markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.markdownDescription%","default":"none"},"csharp.debug.logging.diagnosticsLog.debugEngineAPITracing":{"type":"string","enum":["none","error","all"],"enumDescriptions":["%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.none.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.error.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.all.enumDescription%"],"markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.markdownDescription%","default":"none"},"csharp.debug.logging.diagnosticsLog.debugRuntimeEventTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.debugRuntimeEventTracing.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.expressionEvaluationTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.expressionEvaluationTracing.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.startDebuggingTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.startDebuggingTracing.markdownDescription%","default":false},"csharp.debug.logging.consoleUsageMessage":{"type":"boolean","description":"%generateOptionsSchema.logging.consoleUsageMessage.description%","default":true},"csharp.debug.suppressJITOptimizations":{"type":"boolean","markdownDescription":"%generateOptionsSchema.suppressJITOptimizations.markdownDescription%","default":false},"csharp.debug.symbolOptions.searchPaths":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.searchPaths.description%","default":[]},"csharp.debug.symbolOptions.searchMicrosoftSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchMicrosoftSymbolServer.description%","default":false},"csharp.debug.symbolOptions.searchNuGetOrgSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchNuGetOrgSymbolServer.description%","default":false},"csharp.debug.symbolOptions.cachePath":{"type":"string","description":"%generateOptionsSchema.symbolOptions.cachePath.description%","default":""},"csharp.debug.symbolOptions.moduleFilter.mode":{"type":"string","enum":["loadAllButExcluded","loadOnlyIncluded"],"enumDescriptions":["%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadAllButExcluded.enumDescription%","%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadOnlyIncluded.enumDescription%"],"description":"%generateOptionsSchema.symbolOptions.moduleFilter.mode.description%","default":"loadAllButExcluded"},"csharp.debug.symbolOptions.moduleFilter.excludedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.excludedModules.description%","default":[]},"csharp.debug.symbolOptions.moduleFilter.includedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.includedModules.description%","default":[]},"csharp.debug.symbolOptions.moduleFilter.includeSymbolsNextToModules":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsNextToModules.description%","default":true},"csharp.debug.symbolOptions.moduleFilter.includeSymbolsOnDemand":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsOnDemand.description%","default":true},"csharp.debug.allowFastEvaluate":{"type":"boolean","description":"%generateOptionsSchema.allowFastEvaluate.description%","default":true},"dotnet.unitTestDebuggingOptions":{"type":"object","description":"%configuration.dotnet.unitTestDebuggingOptions%","default":{},"properties":{"sourceFileMap":{"type":"object","markdownDescription":"%generateOptionsSchema.sourceFileMap.markdownDescription%","additionalProperties":{"type":"string"}},"justMyCode":{"type":"boolean","markdownDescription":"%generateOptionsSchema.justMyCode.markdownDescription%","default":true},"requireExactSource":{"type":"boolean","markdownDescription":"%generateOptionsSchema.requireExactSource.markdownDescription%","default":true},"enableStepFiltering":{"type":"boolean","markdownDescription":"%generateOptionsSchema.enableStepFiltering.markdownDescription%","default":true},"logging":{"description":"%generateOptionsSchema.logging.description%","type":"object","required":[],"default":{},"properties":{"exceptions":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.exceptions.markdownDescription%","default":true},"moduleLoad":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.moduleLoad.markdownDescription%","default":true},"programOutput":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.programOutput.markdownDescription%","default":true},"threadExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.threadExit.markdownDescription%","default":false},"processExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.processExit.markdownDescription%","default":true}}},"suppressJITOptimizations":{"type":"boolean","markdownDescription":"%generateOptionsSchema.suppressJITOptimizations.markdownDescription%","default":false},"symbolOptions":{"description":"%generateOptionsSchema.symbolOptions.description%","default":{"searchPaths":[],"searchMicrosoftSymbolServer":false,"searchNuGetOrgSymbolServer":false},"type":"object","properties":{"searchPaths":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.searchPaths.description%","default":[]},"searchMicrosoftSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchMicrosoftSymbolServer.description%","default":false},"searchNuGetOrgSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchNuGetOrgSymbolServer.description%","default":false},"cachePath":{"type":"string","description":"%generateOptionsSchema.symbolOptions.cachePath.description%","default":""},"moduleFilter":{"description":"%generateOptionsSchema.symbolOptions.moduleFilter.description%","default":{"mode":"loadAllButExcluded","excludedModules":[]},"type":"object","required":["mode"],"properties":{"mode":{"type":"string","enum":["loadAllButExcluded","loadOnlyIncluded"],"enumDescriptions":["%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadAllButExcluded.enumDescription%","%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadOnlyIncluded.enumDescription%"],"description":"%generateOptionsSchema.symbolOptions.moduleFilter.mode.description%","default":"loadAllButExcluded"},"excludedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.excludedModules.description%","default":[]},"includedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.includedModules.description%","default":[]},"includeSymbolsNextToModules":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsNextToModules.description%","default":true},"includeSymbolsOnDemand":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsOnDemand.description%","default":true}}}}},"sourceLinkOptions":{"markdownDescription":"%generateOptionsSchema.sourceLinkOptions.markdownDescription%","default":{"*":{"enabled":true}},"type":"object","additionalItems":{"type":"object","properties":{"enabled":{"title":"boolean","markdownDescription":"%generateOptionsSchema.sourceLinkOptions.additionalItems.enabled.markdownDescription%","default":"true"}}}},"allowFastEvaluate":{"type":"boolean","description":"%generateOptionsSchema.allowFastEvaluate.description%","default":true},"targetArchitecture":{"type":"string","markdownDescription":"%generateOptionsSchema.targetArchitecture.markdownDescription%","enum":["x86_64","arm64"]},"type":{"type":"string","enum":["coreclr","clr"],"description":"Type type of code to debug. Can be either 'coreclr' for .NET Core debugging, or 'clr' for Desktop .NET Framework. 'clr' only works on Windows as the Desktop framework is Windows-only.","default":"coreclr"},"debugServer":{"type":"number","description":"For debug extension development only: if a port is specified VS Code tries to connect to a debug adapter running in server mode","default":4711}}},"dotnet.unitTests.runSettingsPath":{"type":"string","description":"Path to the .runsettings file which should be used when running unit tests. (Previously `omnisharp.testRunSettings`)"}}},{"title":"LSP Server","order":9,"properties":{"dotnet.preferCSharpExtension":{"scope":"resource","type":"boolean","default":false,"description":"%configuration.dotnet.preferCSharpExtension%"},"dotnet.dotnetPath":{"type":"string","scope":"machine-overridable","description":"%configuration.dotnet.dotnetPath%"},"dotnet.server.path":{"type":"string","scope":"machine-overridable","description":"%configuration.dotnet.server.path%"},"dotnet.server.startTimeout":{"type":"number","scope":"machine-overridable","default":30000,"description":"%configuration.dotnet.server.startTimeout%"},"dotnet.server.waitForDebugger":{"type":"boolean","scope":"machine-overridable","default":false,"description":"%configuration.dotnet.server.waitForDebugger%"},"dotnet.server.trace":{"scope":"window","type":"string","enum":["Trace","Debug","Information","Warning","Error","Critical","None"],"default":"Information","description":"%configuration.dotnet.server.trace%"},"dotnet.server.extensionPaths":{"scope":"machine-overridable","type":["array",null],"items":{"type":"string"},"default":null,"description":"%configuration.dotnet.server.extensionPaths%"},"dotnet.server.crashDumpPath":{"scope":"machine-overridable","type":"string","default":null,"description":"%configuration.dotnet.server.crashDumpPath%"},"dotnet.projects.binaryLogPath":{"scope":"machine-overridable","type":"string","default":null,"description":"Sets a path where MSBuild binary logs are written to when loading projects, to help diagnose loading errors."},"dotnet.projects.enableAutomaticRestore":{"type":"boolean","default":true,"description":"%configuration.dotnet.projects.enableAutomaticRestore%"},"razor.languageServer.directory":{"type":"string","scope":"machine-overridable","description":"%configuration.razor.languageServer.directory%","order":90},"razor.languageServer.debug":{"type":"boolean","scope":"machine-overridable","default":false,"description":"%configuration.razor.languageServer.debug%","order":90},"razor.server.trace":{"scope":"window","type":"string","enum":["Trace","Debug","Information","Warning","Error","Critical","None"],"order":90,"default":"Information","description":"%configuration.razor.server.trace%"}}},{"title":"OmniSharp","order":10,"properties":{"dotnet.server.useOmnisharp":{"type":"boolean","default":false,"description":"Switches to use the Omnisharp server for language features when enabled (requires restart). This option will not be honored with C# Dev Kit installed.","order":0},"csharp.format.enable":{"type":"boolean","default":true,"description":"Enable/disable default C# formatter (requires restart)."},"csharp.suppressDotnetInstallWarning":{"type":"boolean","default":false,"description":"Suppress the warning that the .NET Core SDK is not on the path."},"csharp.suppressDotnetRestoreNotification":{"type":"boolean","default":false,"description":"Suppress the notification window to perform a 'dotnet restore' when dependencies can't be resolved."},"csharp.suppressProjectJsonWarning":{"type":"boolean","default":false,"description":"Suppress the warning that project.json is no longer a supported project format for .NET Core applications"},"csharp.suppressBuildAssetsNotification":{"type":"boolean","default":false,"description":"Suppress the notification window to add missing assets to build or debug the application."},"csharp.suppressHiddenDiagnostics":{"type":"boolean","default":true,"description":"Suppress 'hidden' diagnostics (such as 'unnecessary using directives') from appearing in the editor or the Problems pane."},"csharp.referencesCodeLens.filteredSymbols":{"type":"array","items":{"type":"string"},"default":[],"description":"Array of custom symbol names for which CodeLens should be disabled."},"csharp.maxProjectFileCountForDiagnosticAnalysis":{"type":"number","default":1000,"description":"Specifies the maximum number of files for which diagnostics are reported for the whole workspace. If this limit is exceeded, diagnostics will be shown for currently opened files only. Specify 0 or less to disable the limit completely."},"csharp.semanticHighlighting.enabled":{"type":"boolean","default":true,"description":"Enable/disable Semantic Highlighting for C# files (Razor files currently unsupported). Defaults to false. Close open files for changes to take effect.","scope":"window"},"csharp.showOmnisharpLogOnError":{"type":"boolean","default":true,"description":"Shows the OmniSharp log in the Output pane when OmniSharp reports an error."},"omnisharp.useModernNet":{"type":"boolean","default":true,"scope":"window","title":"Use .NET 6 build of OmniSharp","description":"Use OmniSharp build for .NET 6. This version _does not_ support non-SDK-style .NET Framework projects, including Unity. SDK-style Framework, .NET Core, and .NET 5+ projects should see significant performance improvements."},"omnisharp.sdkPath":{"type":"string","scope":"window","description":"Specifies the path to a .NET SDK installation to use for project loading instead of the highest version installed. Applies when \"useModernNet\" is set to true. Example: /home/username/dotnet/sdks/6.0.300."},"omnisharp.sdkVersion":{"type":"string","scope":"window","description":"Specifies the version of the .NET SDK to use for project loading instead of the highest version installed. Applies when \"useModernNet\" is set to true. Example: 6.0.300."},"omnisharp.sdkIncludePrereleases":{"type":"boolean","scope":"window","default":true,"description":"Specifies whether to include preview versions of the .NET SDK when determining which version to use for project loading. Applies when \"useModernNet\" is set to true."},"omnisharp.monoPath":{"type":"string","scope":"machine","description":"Specifies the path to a mono installation to use when \"useModernNet\" is set to false, instead of the default system one. Example: \"/Library/Frameworks/Mono.framework/Versions/Current\""},"omnisharp.loggingLevel":{"type":"string","default":"information","enum":["trace","debug","information","warning","error","critical"],"description":"Specifies the level of logging output from the OmniSharp server."},"omnisharp.autoStart":{"type":"boolean","default":true,"description":"Specifies whether the OmniSharp server will be automatically started or not. If false, OmniSharp can be started with the 'Restart OmniSharp' command"},"omnisharp.projectFilesExcludePattern":{"type":"string","default":"**/node_modules/**,**/.git/**,**/bower_components/**","description":"The exclude pattern used by OmniSharp to find all project files."},"omnisharp.projectLoadTimeout":{"type":"number","default":60,"description":"The time Visual Studio Code will wait for the OmniSharp server to start. Time is expressed in seconds."},"omnisharp.maxProjectResults":{"type":"number","default":250,"description":"The maximum number of projects to be shown in the 'Select Project' dropdown (maximum 250)."},"omnisharp.useEditorFormattingSettings":{"type":"boolean","default":true,"description":"Specifes whether OmniSharp should use VS Code editor settings for C# code formatting (use of tabs, indentation size)."},"omnisharp.minFindSymbolsFilterLength":{"type":"number","default":0,"description":"The minimum number of characters to enter before 'Go to Symbol in Workspace' operation shows any results."},"omnisharp.maxFindSymbolsItems":{"type":"number","default":1000,"description":"The maximum number of items that 'Go to Symbol in Workspace' operation can show. The limit is applied only when a positive number is specified here."},"omnisharp.disableMSBuildDiagnosticWarning":{"type":"boolean","default":false,"description":"Specifies whether notifications should be shown if OmniSharp encounters warnings or errors loading a project. Note that these warnings/errors are always emitted to the OmniSharp log"},"omnisharp.enableMsBuildLoadProjectsOnDemand":{"type":"boolean","default":false,"description":"If true, MSBuild project system will only load projects for files that were opened in the editor. This setting is useful for big C# codebases and allows for faster initialization of code navigation features only for projects that are relevant to code that is being edited. With this setting enabled OmniSharp may load fewer projects and may thus display incomplete reference lists for symbols."},"omnisharp.enableEditorConfigSupport":{"type":"boolean","default":true,"description":"Enables support for reading code style, naming convention and analyzer settings from .editorconfig."},"omnisharp.enableDecompilationSupport":{"type":"boolean","default":false,"scope":"machine","description":"Enables support for decompiling external references instead of viewing metadata."},"omnisharp.enableLspDriver":{"type":"boolean","default":false,"description":"Enables support for the experimental language protocol based engine (requires reload to setup bindings correctly)"},"omnisharp.organizeImportsOnFormat":{"type":"boolean","default":false,"description":"Specifies whether 'using' directives should be grouped and sorted during document formatting."},"omnisharp.enableAsyncCompletion":{"type":"boolean","default":false,"description":"(EXPERIMENTAL) Enables support for resolving completion edits asynchronously. This can speed up time to show the completion list, particularly override and partial method completion lists, at the cost of slight delays after inserting a completion item. Most completion items will have no noticeable impact with this feature, but typing immediately after inserting an override or partial method completion, before the insert is completed, can have unpredictable results."},"omnisharp.dotNetCliPaths":{"type":"array","items":{"type":"string"},"description":"Paths to a local download of the .NET CLI to use for running any user code.","uniqueItems":true},"razor.plugin.path":{"type":"string","scope":"machine","description":"Overrides the path to the Razor plugin dll."},"razor.devmode":{"type":"boolean","default":false,"description":"Forces the omnisharp-vscode extension to run in a mode that enables local Razor.VSCode deving."},"razor.format.enable":{"type":"boolean","scope":"window","default":true,"description":"Enable/disable default Razor formatter."},"razor.format.codeBlockBraceOnNextLine":{"type":"boolean","scope":"window","default":false,"description":"Forces the open brace after an @code or @functions directive to be on the following line."},"razor.completion.commitElementsWithSpace":{"type":"boolean","scope":"window","default":"false","description":"Specifies whether to commit tag helper and component elements with a space."}}}],"jsonValidation":[{"fileMatch":["appsettings.json","appsettings.*.json"],"url":"https://json.schemastore.org/appsettings"},{"fileMatch":"project.json","url":"http://json.schemastore.org/project"},{"fileMatch":"omnisharp.json","url":"http://json.schemastore.org/omnisharp"},{"fileMatch":"global.json","url":"http://json.schemastore.org/global"},{"fileMatch":"launchSettings.json","url":"https://json.schemastore.org/launchsettings.json"}],"snippets":[{"language":"csharp","path":"./snippets/csharp.json"}],"semanticTokenTypes":[{"id":"razorComponentElement","description":"A Razor component element"},{"id":"razorComponentAttribute","description":"A Razor component attribute"},{"id":"razorTagHelperElement","description":"A Razor TagHelper Element"},{"id":"razorTagHelperAttribute","description":"A Razor TagHelper Attribute"},{"id":"razorTransition","description":"A Razor transition"},{"id":"razorDirectiveAttribute","description":"A Razor Directive Attribute"},{"id":"razorDirectiveColon","description":"A colon between directive attribute parameters"},{"id":"razorDirective","description":"A Razor directive such as 'code' or 'function'"},{"id":"razorComment","description":"A Razor comment"},{"id":"markupCommentPunctuation","description":"The '@' or '*' of a Razor comment."},{"id":"markupTagDelimiter","description":"Markup delimiters like '<', '>', and '/'."},{"id":"markupOperator","description":"Delimiter for Markup Attribute Key-Value pairs."},{"id":"markupElement","description":"The name of a Markup element."},{"id":"markupAttribute","description":"The name of a Markup attribute."},{"id":"markupAttributeQuote","description":"A token that represents an attribute quote in a Markup attribute."},{"id":"markupAttributeValue","description":"The value of a Markup attribute."},{"id":"markupComment","description":"The contents of a Markup comment."},{"id":"markupCommentPunctuation","description":"The begining or ending punctuation of a Markup comment."},{"id":"excludedCode","description":"A token that represents inactive code."},{"id":"controlKeyword","description":"A token that represents a control-flow keyword.","superType":"keyword"},{"id":"operatorOverloaded","description":"A declaration or reference to an overloaded operator."},{"id":"whitespace","description":"A token that represents whitespace."},{"id":"text","description":"A token that represents text."},{"id":"preprocessorText","description":"Text associated with a preprocessor directive."},{"id":"punctuation","description":"A token that represents punctuation."},{"id":"stringVerbatim","superType":"string","description":"A token that represents a verbatim string."},{"id":"stringEscapeCharacter","superType":"string","description":"An escape character within a string."},{"id":"recordClass","superType":"class","description":"A definition or reference to a record class type."},{"id":"delegate","superType":"method","description":"A definition or reference to a delegate type."},{"id":"module","superType":"namespace","description":"A definition or reference to a module name."},{"id":"recordStruct","superType":"struct","description":"A definition or reference to a record struct type."},{"id":"field","superType":"property","description":"A definition or reference to a field."},{"id":"constant","superType":"variable","description":"A definition or reference to a constant."},{"id":"extensionMethod","superType":"method","description":"A definition or reference to an extension method"},{"id":"xmlDocCommentAttributeName","description":"A token that represents an attribute in an XML documentation comment"},{"id":"xmlDocCommentAttributeQuotes","description":"A token that represents an attribute quote in an XML documentation comment"},{"id":"xmlDocCommentAttributeValue","description":"A token that represents an attribute value in an XML documentation comment"},{"id":"xmlDocCommentCDataSection","description":"A token that represents a CDATA section in an XML documentation comment"},{"id":"xmlDocCommentComment","description":"A token that represents a comment in an XML documentation comment"},{"id":"xmlDocCommentDelimiter","description":"A token that represents a delimeter in an XML documentation comment"},{"id":"xmlDocCommentEntityReference","description":"A token that represents reference to an entity in an XML documentation comment"},{"id":"xmlDocCommentName","description":"A token that represents a name in an XML documentation comment"},{"id":"xmlDocCommentProcessingInstruction","description":"A token that represents a processing instruction in an XML documentation comment"},{"id":"xmlDocCommentText","description":"A token that represents text in an XML documentation comment"},{"id":"xmlLiteralAttributeName","description":"A token that represents an attribute name in an XML literal"},{"id":"xmlLiteralAttributeQuotes","description":"A token that represents an attribute quote in an XML literal"},{"id":"xmlLiteralAttributeValue","description":"A token that represents an attribute value in an XML literal"},{"id":"xmlLiteralCDataSection","description":"A token that represents a CDATA section in an XML literal"},{"id":"xmlLiteralComment","description":"A token that represents a comment in an XML literal"},{"id":"xmlLiteralDelimiter","description":"A token that represents a delimiter in an XML literal"},{"id":"xmlLiteralEmbeddedExpression","description":"A token that represents an emebedded expression in an XML literal"},{"id":"xmlLiteralEntityReference","description":"A token that represents a reference to an entity in an XML literal"},{"id":"xmlLiteralName","description":"A token that represents a name in an XML literal"},{"id":"xmlLiteralProcessingInstruction","description":"A token that represents a processing instruction in an XML literal"},{"id":"xmlLiteralText","description":"A token that represents text in an XML literal"},{"id":"regexComment","description":"A token that represents a comment in a regex string"},{"id":"regexCharacterClass","description":"A token that represents a character class in a regex string"},{"id":"regexAnchor","description":"A token that represents an anchor in a regex string"},{"id":"regexQuantifier","description":"A token that represents a quantifier in a regex string"},{"id":"regexGrouping","description":"A token that represents a group in a regex string"},{"id":"regexAlternation","description":"A token that represents an alternation in a regex string"},{"id":"regexText","description":"A token that represents text in a regex string"},{"id":"regexSelfEscapedCharacter","description":"A token that represents a self escaped character in a regex string"},{"id":"regexOtherEscape","description":"A token that represents an escape in a regex string"},{"id":"jsonComment","description":"A token that represents a comment in a JSON string"},{"id":"jsonNumber","description":"A token that represents a number in a JSON string"},{"id":"jsonString","description":"A token that represents a string in a JSON string"},{"id":"jsonKeyword","description":"A token that represents a keyword in a JSON string"},{"id":"jsonText","description":"A token that represents text in a JSON string"},{"id":"jsonOperator","description":"A token that represents an operator in a JSON string"},{"id":"jsonPunctuation","description":"A token that represents punctuation in a JSON string"},{"id":"jsonArray","description":"A token that represents an array in a JSON string"},{"id":"jsonObject","description":"A token that represents an object in a JSON string"},{"id":"jsonPropertyName","description":"A token that represents a property name in a JSON string"},{"id":"jsonConstructorName","description":"A token that represents a constructor in a JSON string"}],"semanticTokenModifiers":[],"semanticTokenScopes":[{"language":"aspnetcorerazor","scopes":{"razorComponentElement":["entity.name.class.element.component"],"razorComponentAttribute":["entity.name.class.attribute.component"],"razorTagHelperElement":["entity.name.class.element.taghelper"],"razorTagHelperAttribute":["entity.name.class.attribute.taghelper"],"razorTransition":["keyword.control.razor.transition"],"razorDirectiveAttribute":["keyword.control.razor.directive.attribute","keyword.control.cshtml.directive.attribute"],"razorDirectiveColon":["keyword.control.razor.directive.colon","keyword.control.cshtml.directive.colon"],"razorDirective":["keyword.control.razor.directive","keyword.control.cshtml.directive"],"razorComment":["comment.block.razor"],"razorCommentTransition":["meta.comment.razor","keyword.control.cshtml.transition"],"razorCommentStar":["keyword.control.razor.comment.star","meta.comment.razor"],"angleBracket":["punctuation.definition.tag"],"forwardSlash":["punctuation.definition.tag"],"equals":["punctuation.separator.key-value.html"],"markupElement":["entity.name.tag.html"],"markupAttribute":["entity.other.attribute-name.html"],"markupAttributeQuote":["punctuation.definition.tag.html"],"markupAttributeValue":["punctuation.definition.entity.html"],"markupComment":["comment.block.html"],"markupCommentPunctuation":["punctuation.definition.comment.html","comment.block.html"],"markupTagDelimiter":["punctuation.definition.tag.html"],"keyword":["keyword.cs"],"excludedCode":["support.other.excluded.cs"],"controlKeyword":["keyword.control.cs"],"operatorOverloaded":["entity.name.function.member.overload.cs"],"preprocessorText":["meta.preprocessor.string.cs"],"punctuation":["punctuation.cs"],"stringVerbatim":["string.verbatim.cs"],"stringEscapeCharacter":["constant.character.escape.cs"],"delegate":["entity.name.type.delegate.cs"],"module":["entity.name.type.module.cs"],"field":["entity.name.variable.field.cs"],"constant":["variable.other.constant"],"extensionMethod":["entity.name.function.extension.cs"],"xmlDocCommentAttributeName":["comment.documentation.attribute.name.cs"],"xmlDocCommentAttributeQuotes":["comment.documentation.attribute.quotes.cs"],"xmlDocCommentAttributeValue":["comment.documentation.attribute.value.cs"],"xmlDocCommentCDataSection":["comment.documentation.cdata.cs"],"xmlDocCommentComment":["comment.documentation.comment.cs"],"xmlDocCommentDelimiter":["comment.documentation.delimiter.cs"],"xmlDocCommentEntityReference":["comment.documentation.entityReference.cs"],"xmlDocCommentName":["comment.documentation.name.cs"],"xmlDocCommentProcessingInstruction":["comment.documentation.processingInstruction.cs"],"xmlDocCommentText":["comment.documentation.cs"],"xmlLiteralAttributeName":["entity.other.attribute-name.localname.xml"],"xmlLiteralAttributeQuotes":["string.quoted.double.xml"],"xmlLiteralAttributeValue":["meta.tag.xml"],"xmlLiteralCDataSection":["string.quoted.double.xml"],"xmlLiteralComment":["comment.block.xml"],"xmlLiteralDelimiter":["text.xml"],"xmlLiteralEmbeddedExpression":["meta.tag.xml"],"xmlLiteralEntityReference":["meta.tag.xml"],"xmlLiteralName":["entity.name.tag.localname.xml"],"xmlLiteralProcessingInstruction":["meta.tag.xml"],"xmlLiteralText":["text.xml"],"regexComment":["string.regexp.comment.cs"],"regexCharacterClass":["constant.character.character-class.regexp.cs"],"regexAnchor":["keyword.control.anchor.regexp.cs"],"regexQuantifier":["keyword.operator.quantifier.regexp.cs"],"regexGrouping":["punctuation.definition.group.regexp.cs"],"regexAlternation":["keyword.operator.or.regexp.cs"],"regexText":["string.regexp"],"regexSelfEscapedCharacter":["string.regexp.self-escaped-character.cs"],"regexOtherEscape":["string.regexp.other-escape.cs"],"jsonComment":["comment.line.double-slash.js"],"jsonNumber":["constant.numeric.json"],"jsonString":["string.quoted.double.json"],"jsonKeyword":["constant.language.json"],"jsonText":["string.quoted.double.json"],"jsonOperator":["string.quoted.double.json"],"jsonPunctuation":["punctuation.separator.dictionary.key-value.json"],"jsonArray":["punctuation.definition.array.begin.json"],"jsonObject":["punctuation.definition.dictionary.begin.json"],"jsonPropertyName":["support.type.property-name.json"],"jsonConstructorName":["support.type.property-name.json"]}},{"language":"csharp","scopes":{"typeParameter":["entity.name.type.type-parameter"],"keyword":["keyword.cs"],"excludedCode":["support.other.excluded.cs"],"controlKeyword":["keyword.control.cs"],"operatorOverloaded":["entity.name.function.member.overload.cs"],"preprocessorText":["meta.preprocessor.string.cs"],"punctuation":["punctuation.cs"],"stringVerbatim":["string.verbatim.cs"],"stringEscapeCharacter":["constant.character.escape.cs"],"delegate":["entity.name.type.delegate.cs"],"module":["entity.name.type.module.cs"],"field":["entity.name.variable.field.cs"],"constant":["variable.other.constant"],"extensionMethod":["entity.name.function.extension.cs"],"xmlDocCommentAttributeName":["comment.documentation.attribute.name.cs"],"xmlDocCommentAttributeQuotes":["comment.documentation.attribute.quotes.cs"],"xmlDocCommentAttributeValue":["comment.documentation.attribute.value.cs"],"xmlDocCommentCDataSection":["comment.documentation.cdata.cs"],"xmlDocCommentComment":["comment.documentation.comment.cs"],"xmlDocCommentDelimiter":["comment.documentation.delimiter.cs"],"xmlDocCommentEntityReference":["comment.documentation.entityReference.cs"],"xmlDocCommentName":["comment.documentation.name.cs"],"xmlDocCommentProcessingInstruction":["comment.documentation.processingInstruction.cs"],"xmlDocCommentText":["comment.documentation.cs"],"xmlLiteralAttributeName":["entity.other.attribute-name.localname.xml"],"xmlLiteralAttributeQuotes":["string.quoted.double.xml"],"xmlLiteralAttributeValue":["meta.tag.xml"],"xmlLiteralCDataSection":["string.quoted.double.xml"],"xmlLiteralComment":["comment.block.xml"],"xmlLiteralDelimiter":["text.xml"],"xmlLiteralEmbeddedExpression":["meta.tag.xml"],"xmlLiteralEntityReference":["meta.tag.xml"],"xmlLiteralName":["entity.name.tag.localname.xml"],"xmlLiteralProcessingInstruction":["meta.tag.xml"],"xmlLiteralText":["text.xml"],"regexComment":["string.regexp.comment.cs"],"regexCharacterClass":["constant.character.character-class.regexp.cs"],"regexAnchor":["keyword.control.anchor.regexp.cs"],"regexQuantifier":["keyword.operator.quantifier.regexp.cs"],"regexGrouping":["punctuation.definition.group.regexp.cs"],"regexAlternation":["keyword.operator.or.regexp.cs"],"regexText":["string.regexp"],"regexSelfEscapedCharacter":["string.regexp.self-escaped-character.cs"],"regexOtherEscape":["string.regexp.other-escape.cs"],"jsonComment":["comment.line.double-slash.js"],"jsonNumber":["constant.numeric.json"],"jsonString":["string.quoted.double.json"],"jsonKeyword":["constant.language.json"],"jsonText":["string.quoted.double.json"],"jsonOperator":["string.quoted.double.json"],"jsonPunctuation":["punctuation.separator.dictionary.key-value.json"],"jsonArray":["punctuation.definition.array.begin.json"],"jsonObject":["punctuation.definition.dictionary.begin.json"],"jsonPropertyName":["support.type.property-name.json"],"jsonConstructorName":["support.type.property-name.json"]}}],"languages":[{"id":"aspnetcorerazor","extensions":[".cshtml",".razor"],"mimetypes":["text/x-cshtml"],"configuration":"./src/razor/language-configuration.json","aliases":["ASP.NET Razor"]}],"grammars":[{"language":"aspnetcorerazor","scopeName":"text.aspnetcorerazor","path":"./src/razor/syntaxes/aspnetcorerazor.tmLanguage.json","unbalancedBracketScopes":["text.aspnetcorerazor"]}]}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('README.md', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/README.md', import.meta.url).href, {"mimeType":"text/markdown","size":5962});

registerFileUrl('CHANGELOG.md', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/CHANGELOG.md', import.meta.url).href, {"mimeType":"text/markdown","size":195366});

registerFileUrl('src/razor/syntaxes/aspnetcorerazor.tmLanguage.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/aspnetcorerazor.tmLanguage.json', import.meta.url).href, {"mimeType":"application/json","size":43621});

registerFileUrl('src/razor/language-configuration.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":486});

registerFileUrl('snippets/csharp.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/csharp.json', import.meta.url).href, {"mimeType":"application/json","size":13805});

registerFileUrl('themes/vs2019_dark.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/vs2019_dark.json', import.meta.url).href, {"mimeType":"application/json","size":22886});

registerFileUrl('themes/vs2019_light.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/vs2019_light.json', import.meta.url).href, {"mimeType":"application/json","size":23980});

registerFileUrl('package.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.json', import.meta.url).href, {"mimeType":"application/json","size":231909});

registerFileUrl('package.nls.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.json', import.meta.url).href, {"mimeType":"application/json","size":45809});

registerFileUrl('package.nls.cs.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.cs.json', import.meta.url).href, {"mimeType":"application/json","size":40527});

registerFileUrl('package.nls.de.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.de.json', import.meta.url).href, {"mimeType":"application/json","size":42203});

registerFileUrl('package.nls.es.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.es.json', import.meta.url).href, {"mimeType":"application/json","size":41557});

registerFileUrl('package.nls.fr.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.fr.json', import.meta.url).href, {"mimeType":"application/json","size":42008});

registerFileUrl('package.nls.it.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.it.json', import.meta.url).href, {"mimeType":"application/json","size":41296});

registerFileUrl('package.nls.ja.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.ja.json', import.meta.url).href, {"mimeType":"application/json","size":45906});

registerFileUrl('package.nls.ko.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.ko.json', import.meta.url).href, {"mimeType":"application/json","size":40532});

registerFileUrl('package.nls.pl.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.pl.json', import.meta.url).href, {"mimeType":"application/json","size":42587});

registerFileUrl('package.nls.pt-br.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.pt-br.json', import.meta.url).href, {"mimeType":"application/json","size":39784});

registerFileUrl('package.nls.ru.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.ru.json', import.meta.url).href, {"mimeType":"application/json","size":57252});

registerFileUrl('package.nls.tr.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.tr.json', import.meta.url).href, {"mimeType":"application/json","size":41304});

registerFileUrl('package.nls.zh-cn.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.zh-cn.json', import.meta.url).href, {"mimeType":"application/json","size":34371});

registerFileUrl('package.nls.zh-tw.json', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/package.nls.zh-tw.json', import.meta.url).href, {"mimeType":"application/json","size":34255});

registerFileUrl('images/csharpIcon.png', new URL('../assets/ms-dotnettools.csharp-2.24.17.vsix/csharpIcon.png', import.meta.url).href, {"mimeType":"image/png","size":41371});

export { whenReady };
